﻿using FluentNHibernate.Conventions;
using FluentNHibernate.Conventions.Instances;

namespace $rootnamespace$.Conventions
{
    public class MyReferenceConvention : IReferenceConvention
    {
        public void Apply(IManyToOneInstance instance)
        {
            instance.ForeignKey(string.Format("FK_{0}_{1}", instance.EntityType.Name, instance.Property.Name));
            instance.Cascade.SaveUpdate();
        }
    }
}
