﻿using System;

namespace FT.Architecture.NHibernate.SessionManagement
{
    public class SessionProviderException : Exception
    {
        private readonly ISessionProviderService sessionProviderService;

        public SessionProviderException(ISessionProviderService sessionProviderService)
        {
            this.sessionProviderService = sessionProviderService;
        }

        public SessionProviderException(string message, ISessionProviderService sessionProviderService) : base(message)
        {
            this.sessionProviderService = sessionProviderService;
        }

        public ISessionProviderService SessionProviderService
        {
            get { return sessionProviderService; }
        }
    }
}
