﻿using System.Collections.Generic;

namespace FT.Architecture.Queries
{
    public interface IQueryExecutorService
    {
        IEnumerable<T> Execute<T>(Query<T> query) where T : class;
        
        long Count<T>(Query<T> query);
    }
}
