﻿namespace FT.Architecture.UnitOfWork
{
    public interface IUnitOfWork
    {
        void Initialise();

        IUnitOfWorkInstance Start();

        void Commit();

        void Rollback();

        void Flush();

        bool IsStarted();
    }

    public interface IStatelessUnitOfWork : IUnitOfWork {}
}
