﻿using System;
using FT.Architecture.Entities;

namespace FT.Architecture.Example.Core.Entities
{
    /// <summary>
    /// Represents a Guid-based entity
    /// </summary>
    public interface IGuidEntity : IGenericEntity<Guid> {}

    /// <summary>
    /// Represents a Guid-based entity
    /// </summary>
    public class GuidEntity : GenericEntity<Guid>, IGuidEntity
    {
    }
}