﻿#region Copyright
//       Copyright (c) 2009 - Antoine Jaussoin - http://www.jaussoin.com/blog/
// 
//        This program is free software: you can redistribute it and/or modify
//        it under the terms of the GNU General Public License as published by
//        the Free Software Foundation, either version 3 of the License, or
//        (at your option) any later version.
// 
//        This program is distributed in the hope that it will be useful,
//        but WITHOUT ANY WARRANTY; without even the implied warranty of
//        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//        GNU General Public License for more details.
// 
//        You should have received a copy of the GNU General Public License
//        along with this program.  If not, see <http://www.gnu.org/licenses/>.
#endregion
using FT.Architecture.Example.Core.Engines;
using NUnit.Framework;

namespace FT.Architecture.Tests.Architecture
{
    [TestFixture]
    public class EngineTest : BaseTest
    {
        [Test]
        public void TestTheEngine()
        {
            unitOfWork.Start();
            EngineExample engine = new EngineExample(supermanRepository);
            int count = engine.RunEngine();

            Assert.IsTrue(count > 0, "The engine should return a number greater than 0");

            unitOfWork.Commit();
        }
    }
}
