﻿//#region Copyright
////       Copyright (c) 2009 - Antoine Jaussoin - http://www.jaussoin.com/blog/
//// 
////        This program is free software: you can redistribute it and/or modify
////        it under the terms of the GNU General Public License as published by
////        the Free Software Foundation, either version 3 of the License, or
////        (at your option) any later version.
//// 
////        This program is distributed in the hope that it will be useful,
////        but WITHOUT ANY WARRANTY; without even the implied warranty of
////        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
////        GNU General Public License for more details.
//// 
////        You should have received a copy of the GNU General Public License
////        along with this program.  If not, see <http://www.gnu.org/licenses/>.
//#endregion
//using System;
//using System.Collections.Generic;
//using System.Linq;
//using System.Web.UI;
//using FT.Architecture.Entities;
//using FT.Architecture.Example.Core.Entities.Subscriptions;
//using FT.Architecture.Example.Core.Repositories;
//using FT.Architecture.Example.Core.Entities.Humans;
//using FT.Architecture.Logging;
//using FT.Architecture.UnitOfWork;
//using FT.Architecture.Web.Bases;
//using FT.Architecture.Web.Simulator;
//using NUnit.Framework;

//namespace FT.Architecture.NHibernate.UnitTests.Utils
//{
//    [TestFixture]
//    public class BasePageTest : WebElementTest<BasePage<IExampleUnitOfWork>, IExampleUnitOfWork> { }

//    [TestFixture]
//    public class BaseControlTest : WebElementTest<BaseControl<IExampleUnitOfWork>, IExampleUnitOfWork> { }

//    public class WebElementTest<TWebElement, TUnitOfWork> 
//        where TWebElement : IBaseWebElement<TUnitOfWork>
//        where TUnitOfWork : IUnitOfWork 
//    {
//        private const string RANDOM_KEY = "random_key";
//        private readonly string _fakeWebsitePath = Environment.CurrentDirectory;
//        private const string FAKE_ROOT_PATH = "/";

//        private TWebElement GetWebElement()
//        {
//            var element =  Activator.CreateInstance<TWebElement>();

//            if (element is Control)
//            {
//                Control ctrl = element as Control;
//                ctrl.Page = new Page();
//            }

//            return element;
//        }
        

//        [Test]
//        public void TestStoreField()
//        {
//            TWebElement page = GetWebElement();

//            using (new HttpSimulator(FAKE_ROOT_PATH, _fakeWebsitePath).SimulateRequest())
//            {
//                page.SetField(RANDOM_KEY, "test");

//                Assert.AreEqual("test", page.GetField(RANDOM_KEY, ""));
//            }
//        }

//        [Test]
//        public void TestStoreFieldNoCache()
//        {
//            TWebElement page = GetWebElement();

//            using (new HttpSimulator(FAKE_ROOT_PATH, _fakeWebsitePath).SimulateRequest())
//            {
//                page.SetField(RANDOM_KEY, "test");

//                page.ClearCache();

//                Assert.AreEqual("test", page.GetField(RANDOM_KEY, ""));
//            }
//        }

//        [Test]
//        public void TestStoreEntity()
//        {
//            TWebElement page = GetWebElement();

//            using (new HttpSimulator(FAKE_ROOT_PATH, _fakeWebsitePath).SimulateRequest())
//            unitOfWork.Start();
//                IHuman human = humanRepository.GetRandom();

//                page.SetEntity(RANDOM_KEY, human);

//                Assert.AreEqual(human.ID, page.GetEntity<IHuman>(RANDOM_KEY).ID);
//            }
//        }

//        [Test]
//        public void TestStoreEntityNoCache()
//        {
//            TWebElement page = GetWebElement();

//            using (new HttpSimulator(FAKE_ROOT_PATH, _fakeWebsitePath).SimulateRequest())
//            unitOfWork.Start();
//                IHuman human = humanRepository.GetRandom();

//                page.SetEntity(RANDOM_KEY, human);

//                page.ClearCache();

//                Assert.AreEqual(human.ID, page.GetEntity<IHuman>(RANDOM_KEY).ID);
//            }
//        }

//        [Test]
//        public void TestStoreEntityWithComplexId()
//        {
//        //    TWebElement page = GetWebElement();

//        //    using (new HttpSimulator(FAKE_ROOT_PATH, _fakeWebsitePath).SimulateRequest())
//        //    unitOfWork.Start();
//        //        Subscription human = subscriptionRepository.GetRandom();

//        //        page.SetEntity(RANDOM_KEY, human);

//        //        Assert.AreEqual(human.ID, page.GetEntity<IHuman>(RANDOM_KEY).ID);
//        //    }
//        }

//        [Test]
//        public void TestStoreCollectionOfEntities()
//        {
//            TWebElement page = GetWebElement();

//            using (new HttpSimulator(FAKE_ROOT_PATH, _fakeWebsitePath).SimulateRequest())
//            unitOfWork.Start();
//                var humans = humanRepository.GetUnderAgeHumans();

//                page.SetEntities(RANDOM_KEY, humans);

//                Assert.AreEqual(humans.Count, page.GetEntities<IHuman>(RANDOM_KEY).Count);
//                bool compare = CompareTwoCollections(humans, page.GetEntities<IHuman>(RANDOM_KEY));
//                Assert.IsTrue(compare,"The two collections were not the same");
//            }
//        }

//        [Test]
//        public void TestStoreCollectionOfEntitiesNoCache()
//        {
//            TWebElement page = GetWebElement();
            
//            using (new HttpSimulator(FAKE_ROOT_PATH, _fakeWebsitePath).SimulateRequest())
//            unitOfWork.Start();
//                var humans = humanRepository.GetUnderAgeHumans();

//                page.SetEntities(RANDOM_KEY, humans);

//                page.ClearCache();

//                Assert.AreEqual(humans.Count, page.GetEntities<IHuman>(RANDOM_KEY).Count);
//                bool compare = CompareTwoCollections(humans, page.GetEntities<IHuman>(RANDOM_KEY));
//                Assert.IsTrue(compare, "The two collections were not the same");
//            }
//        }

//        [Test]
//        public void TestStoreBigObject()
//        {
//            TWebElement page = GetWebElement();
           
//            var log = new Log();

//            using (new HttpSimulator(FAKE_ROOT_PATH, _fakeWebsitePath).SimulateRequest())
//            {
//                page.SetObject(RANDOM_KEY, log);

//                Assert.AreEqual(log, page.GetObject<Log>(RANDOM_KEY, null));
//            }
//        }

//        [Test]
//        public void TestStoreBigObjectNoCache()
//        {
//            TWebElement page = GetWebElement();

//            var log = new Log();

//            using (new HttpSimulator(FAKE_ROOT_PATH, _fakeWebsitePath).SimulateRequest())
//            {
//                page.SetObject(RANDOM_KEY, log);

//                page.ClearCache();

//                Assert.AreEqual(log, page.GetObject<Log>(RANDOM_KEY, null));
//            }
//        }

//        [Test]
//        public void TestNormalUnitOfWorkFlow()
//        {
//            TWebElement page = GetWebElement();

//            using (new HttpSimulator(FAKE_ROOT_PATH, _fakeWebsitePath).SimulateRequest())
//            {
//                IUnitOfWork uow;
//                //Simulating the HttpModule which opens a unit of work
//                DAL.GetUnitOfWork();

//                //There should be a current unit of work
//                Assert.IsTrue(DAL.HasCurrentUnitOfWork);
//                Assert.IsNotNull(page.UnitOfWork);
//                Assert.IsTrue(page.UnitOfWork.IsLive);
//                Assert.AreEqual(page.UnitOfWork.Identifier, DAL.Current.Identifier);

//                //Simulating the HttpModule which closes the unit of work
//                uow = DAL.Current;
//                uow.Commit();
//                uow.Dispose();
//            }
//        }

//        [Test]
//        public void TestInterruptingUnitOfWorkManually()
//        {
//            TWebElement page = GetWebElement();

//            using (new HttpSimulator(FAKE_ROOT_PATH, _fakeWebsitePath).SimulateRequest())
//            {
//                IUnitOfWork uow;
//                //Simulating the HttpModule which opens a unit of work
//                DAL.GetUnitOfWork();

//                //There should be a current unit of work
//                Assert.IsTrue(DAL.HasCurrentUnitOfWork);
//                Assert.IsNotNull(page.UnitOfWork);
//                Assert.IsTrue(page.UnitOfWork.IsLive);
//                Assert.AreEqual(page.UnitOfWork.Identifier, DAL.Current.Identifier);

//                //Let's rollback for some reason
//                Assert.IsTrue(page.UnitOfWork.IsLive);
//                page.UnitOfWork.Rollback();
//                Assert.IsFalse(page.UnitOfWork.IsLive);
//                page.UnitOfWork.Dispose();

//                //Let's reopen a unit of work
//                DAL.GetUnitOfWork();
//                Assert.IsTrue(DAL.HasCurrentUnitOfWork);
//                Assert.IsNotNull(page.UnitOfWork);
//                Assert.IsTrue(page.UnitOfWork.IsLive);
//                Assert.AreEqual(page.UnitOfWork.Identifier, DAL.Current.Identifier);


//                //Simulating the HttpModule which closes the unit of work
//                uow = DAL.Current;
//                uow.Commit();
//                uow.Dispose();
//            }
//        }

//        [Test]
//        public void TestInterruptingUnitOfWorkUsingBaseMethods()
//        {
//            TWebElement page = GetWebElement();

//            using (new HttpSimulator(FAKE_ROOT_PATH, _fakeWebsitePath).SimulateRequest())
//            {
//                IUnitOfWork uow;
//                //Simulating the HttpModule which opens a unit of work
//                DAL.GetUnitOfWork();

//                //There should be a current unit of work
//                Assert.IsTrue(DAL.HasCurrentUnitOfWork);
//                Assert.IsNotNull(page.UnitOfWork);
//                Assert.IsTrue(page.UnitOfWork.IsLive);
//                Assert.AreEqual(page.UnitOfWork.Identifier, DAL.Current.Identifier);

//                //Let's rollback for some reason
//                page.Rollback();
                
//                //Let's check that we still have an up and running UoW
//                Assert.IsTrue(DAL.HasCurrentUnitOfWork);
//                Assert.IsNotNull(page.UnitOfWork);
//                Assert.IsTrue(page.UnitOfWork.IsLive);
//                Assert.AreEqual(page.UnitOfWork.Identifier, DAL.Current.Identifier);

//                //Simulating the HttpModule which closes the unit of work
//                uow = DAL.Current;
//                uow.Commit();
//                uow.Dispose();
//            }
//        }



//        private bool CompareTwoCollections<T>(IEnumerable<T> col1, IEnumerable<T> col2) where T:IEntity
//        {
//            if (col1.Count() != col2.Count())
//                return false;

//            foreach (var item1 in col1)
//            {
//                bool found = false;
//                foreach (var item2 in col2)
//                {
//                    if (item2.ID == item1.ID)
//                    {
//                        found = true;
//                        break;
//                    }
//                }

//                if (!found)
//                    return false;
//            }

//            return true;
//        }
//    }
//}
