using System;
using System.IO;
using $rootnamespace$.Mappings;
using FluentNHibernate.Cfg;
using FT.Architecture.NHibernate.Factories;
using NHibernate.Cfg;

namespace $rootnamespace$.Configurations
{
    public class FluentConfigurator : INHibernateConfigurator
    {
        public Configuration Configure()
        {
            var configuration = new Configuration();
            configuration.Configure();

            DirectoryInfo mappingDirectory = new DirectoryInfo("c:\\logs\\mappings");

            if (!mappingDirectory.Exists)
                mappingDirectory.Create();

            try
            {
                return Fluently.Configure(configuration)
                .Mappings(m => m.FluentMappings
                    .AddFromAssemblyOf<MyEntityMapping>()
                    .Conventions.AddFromAssemblyOf<MyEntityMapping>()
                    //.ExportTo(mappingDirectory.FullName)
                    )
                .BuildConfiguration();
            }
            catch (Exception ex)
            {
                
                throw;
            }
            
        }
    }
}
