﻿using System;
using System.Collections.Generic;

namespace FT.Architecture.Utils.Generator
{
    public interface IRandomDataService
    {
        string GetFirstName();

        string GetLastName();

        string GetEmail(string userName);

        string GetEmail();

        int GetNumber(int min, int max);

        int GetAge();

        string GetPhoneNumber();

        string GetAddress();

        string GetCity();

        string GetCountry();

        string GetPostCode();

        char GetLetter();

        DateTime GetDate(DateTime from, DateTime to);

        DateTime GetDate();

        DateTime GetBirthday();

        T GetEnumeration<T>();

        T GetObject<T>(IEnumerable<T> objects);

        IEnumerable<T> GetDifferentObjects<T>(int numberOfObjects, IEnumerable<T> poolOfObjects);
    }
}
