﻿using FT.Architecture.Entities;

namespace FT.Architecture.Repositories
{
    public interface IRepositoryService
    {
        IRepository<T> GetRepository<T>() where T : class, IGenericEntity<long>;

        IGenericRepository<T, TId> GetRepository<T, TId>() where T : class, IGenericEntity<TId>;

        INonGenericRepository GetRepository();
    }
}
